/*
 En klasse for å representere  et sirkelobjekt
 Et kall på funksjonen sirkel() tjener som en konstrukør
 og setter opp objektet
*/
function sirkel(xpos,ypos,radius,col){
  // egenskaper, attributter
  this.xPos=xpos;
  this.yPos=ypos;
  this.radius=radius;
  this.col=col;
  //--------------
  // funksjoner
  this.tegn=
	function(){
		if(this.harFokus)
			fill(255,0,0);
		else
			fill(this.col);
		ellipse(this.xPos,this.yPos,
				2*this.radius,2*this.radius);
	}
	
  this.flytt=
	function(){
		// holder oss inne i skissen
		this.xPos=max(0,min(width,mouseX));
		this.yPos=max(0,min(height,mouseY));
	}
	
  this.erTruffet=
	function(){
		return dist(mouseX,mouseY,this.xPos,this.yPos) < this.radius;
	}
	
  this.settFokus=
	function(on){
		this.harFokus=on
	}
}