/*
Vi vil lage en scene med noen sirkler
vi kan flytte på, dragge
*/
// sirklene, en array av sirkelobjekter
var sirkelListe=new Array();
// drar vi på en kule
var dragged=false;
 
function setup(){
  createCanvas(200,200);
  // plasser nye sirkelobjekter i kulelista
  // i tilfeldige posisjoner
  for(var ix=0;ix < 10; ix++){
    sirkelListe[ix] = 
		new sirkel(int(random(10,width-10)),
               int (random(10,height-10)),
					10, color(0,255,255));
  }
}
 
function draw(){
  background(255,255,255);
  // be sirklene om å tegne seg
  for(var ix=0;ix < sirkelListe.length; ix++){
    sirkelListe[ix].tegn();
  }
}

function mousePressed(){
  // har vi truffet noen sirkel ?
  for(var ix=sirkelListe.length-1;ix >=0; ix--){
    if(sirkelListe[ix].erTruffet()){
      // denne sirkelen er truffet og får fokus
      sirkelListe[ix].settFokus(true);
      // flytt den bakerst i lista så den blir tegnet sist
		var tmp=sirkelListe[ix];
		sirkelListe[ix]=sirkelListe[sirkelListe.length-1];
		sirkelListe[sirkelListe.length-1]=tmp;
      // husk at vi dragger
		dragged=true;
      return;
    }
  }
}
  
function mouseDragged(){
  if(dragged)
	sirkelListe[sirkelListe.length-1].flytt()
}
  
function mouseReleased(){
 if (dragged){
    sirkelListe[sirkelListe.length-1].settFokus(false);
    dragged=false;
  }
}
