/*
Preparerer JSON-data for uttegning
*/
function jsonData(jsonObjekt){
	//-----------------------
	// setter opp data fra et JSONObject
	this.tittel=jsonObjekt.tittel;
	this.elementer=jsonObjekt.resultater;
	this.maxVerdi=0;
	this.sum=0;
	// regn om til prosent. hvis det er prosent
	// fra før så forblir det prosent
	for(var i=0;i < this.elementer.length;i++){
		this.maxVerdi=
			Math.max(this.elementer[i].verdi,this.maxVerdi);
		this.sum+=this.elementer[i].verdi;
		// hvit hvis fargen mangler
		if(!this.elementer[i].farge)
			this.elementer[i].farge="255,255,255";

	}
	// lag prosent
	for(var i=0;i < this.elementer.length;i++){
		this.elementer[i].verdi=
			this.elementer[i].verdi*100/this.sum;
	}
	this.maxVerdi=this.maxVerdi*100/this.sum;
	
	//---------------------------------
	// attributtene under må være med
	// de brukes av tegnefunksjonen
	this.getAntallVerdier=function(){
		return this.elementer.length;
	}
	this.getVerdi=function(i){
		return this.elementer[i].verdi;
	}
	this.getMaxVerdi=function(i){
		return this.maxVerdi;
	}	
	this.getNavn=function(i){
		return this.elementer[i].navn;
	}
	this.getTittel=function(){
		return this.tittel;
	}
	this.getFarge=function(i){
		var rgb =this.elementer[i].farge.split(",");
		return color(parseInt(rgb[0]),
						parseInt(rgb[1]),
						parseInt(rgb[2]));
	}
}