// administrasjon av verdier og ruter

// bytter om innholdet i to ruter
function byttInnhold(r1,k1,r2,k2){
	var tmp=rutene[r2][k2].getVerdi();
	rutene[r2][k2].setVerdi(rutene[r1][k1].getVerdi());
	rutene[r1][k1].setVerdi(tmp);
}
// setter opp ruteverdier basert på noen
// kjente løsninger
function setOppRutene(){
	// lag et magisk kvadrat, 4x4 array
	var verdier=lagVerdier();

	//oppretter ruter basert på de verdiene vi har funnet		
	rutene = new Array(4);
	for (var i = 0; i < 4; i++) {
		rutene[i] = new Array(4);
	}
	for(var r =0;r<4;r++)
	for(var k =0;k<4;k++)			
		rutene[r][k]=new rute(r,k, ruteKant*(k+1),ruteKant*(r+1),verdier[r][k]);
	// setter opp kolonne med radsummer
	radSumRuter= new Array(4);
	for(var r=0;r < 4; r++)
		radSumRuter[r]=new rute(r,0, ruteKant*(6),ruteKant*(r+1),0);
	// setter opp rad med kolonnesummer
	kolSumRuter= new Array(4);
	for(var k=0;k < 4; k++)
		kolSumRuter[k]=new rute(0,k, ruteKant*(k+1),ruteKant*(6),0);
	// beregn summer
	oppdaterSummer();		
	// stokk ruter, dvs. 
	// flytt om intil vi er sikre på at vi ikke legger ut
	// et ferdig løst problem
	while(recalculateSquares())
	{
	  var swaps=tilfeldigTall(4,10);
	  for(var ix=0; ix<swaps; ix++)
	  {
		 byttInnhold(
				tilfeldigTall(0,3),tilfeldigTall(0,3),
				tilfeldigTall(0,3),tilfeldigTall(0,3));
	  }
  }	  
}

function oppdaterSummer(){
	for(var r=0; r < 4; r++){
		radSumRuter[r].setVerdi(rutene[r][0].getVerdi()+
		                        rutene[r][1].getVerdi()+
										rutene[r][2].getVerdi()+
										rutene[r][3].getVerdi());
	}
	for(var k=0; k < 4; k++){
		kolSumRuter[k].setVerdi(rutene[0][k].getVerdi()+
		                        rutene[1][k].getVerdi()+
										rutene[2][k].getVerdi()+
										rutene[3][k].getVerdi());
	}
}

function recalculateSquares()
{
  //returnerer true hvis alle summene er 34
  oppdaterSummer()
  for(var i=0; i< 4; i++){
	  if(radSumRuter[i].getVerdi()!=34)
		  return false
	  if(kolSumRuter[i].getVerdi()!=34)
		  return false
  }
  return true;
}

function erViFerdig(){
	return recalculateSquares();
}

