/*
Setter opp en skisse som er motoren i framstillingen
*/

var resultater;	// datakilde
var sesongen;		// aktuell sesong
var runde;			// aktuell runde
var obj; // det vi laster opp fra fil

// Dette gjøres før noe annet skjer
function preload() {
	// setter oppsesongen så snart data er lastet
	obj=loadJSON("data/Eliteserien2016.json",preparerData)
}


function preparerData(){

	// set opp en sesong
	sesongen=new sesong(obj);
	//oppdater lagstatus etter alle rundene
	sesongen.oppDater(sesongen.getAntallRunder());
	// sett maxpoeng (hjelper oss å tegne)
	sesongen.setMaxPoeng();
	// overskriften
	overskrift=sesongen.getLiga()+" "+sesongen.getAar();
	runde=0;
	//oppdater slider, max og value
	var slider=document.getElementById("runden")
	slider.max=sesongen.getAntallRunder();
	slider.value=runde;
}

function setup(){
	var canvas = createCanvas(800,500);
	canvas.parent('canvasHere');
	runde=0;
	document.getElementById("runden").value=runde;
};

function draw(){
	background(255);
	push();	
		fill(0);
		textAlign(CENTER,TOP);
		textSize(20);
		text(overskrift+"    -   runde: "+runde,width/2,2);
	pop();
	runde=document.getElementById("runden").value;
	if(runde > sesongen.getAntallRunder()){
		runde=sesongen.getAntallRunder();
	}		
	sesongen.oppDater(runde);
	tegnSesongBobler(sesongen,runde);
}




