/* En analog kokke
   anta kvadratisk tegneflate
*/
var senterX,senterY;
var radius;
function setup(){
	var canvas = createCanvas(200, 200);
	canvas.parent("canvasHer");
	senterX=width/2;
	senterY=height/2;
	radius=min(width,height)/2-10;
	// hvert sekund
	frameRate(1);
}
function draw(){
	background(255);
	tegnKlokke();
}
function tegnKlokke(){
  var sekund=second();
  var minutt=minute();
  var time=hour();
  push();
  smooth();
    translate(senterX,senterY);
    tegnSkive();
    // tegn sekundviseren
    push();      
      strokeWeight(1);
      rotate((1.0*sekund/60)*TWO_PI);
      line(0,0,0,-radius);
    pop();
    // tegn minuttviseren
    push();      
      strokeWeight(3);
      rotate((1.0*minutt/60)*TWO_PI);
      line(0,0,0,-radius*0.8);
    pop();
    // tegn timeviseren
    push();
      strokeWeight(5);
      rotate((1.0*time/12)*TWO_PI);
      // pluss litt av en time
      rotate((TWO_PI/12)*(1.0*minutt/60));
      line(0,0,0,-radius*0.5);
    pop();
   pop();
}
function tegnSkive(){
  push();
    strokeWeight(1);
    fill(220,220,255);
    ellipseMode(RADIUS);
    ellipse(0,0,radius,radius);
    fill(0);
    for(var ix=0; ix < 12; ix++){
      push();
        rotate((1.0*ix/12)*TWO_PI);
        translate(0,radius);
        ellipse(0,0,3,3);
      pop();
    }
  pop();
}
